import math
#from python_matrix_operations import *
import ctypes
import os
import sys
import numpy as np
import elasticity_toolbox as elast

# Komposit beschreibt ein Material mit 
# oberer Schicht: orthotrop (Holz), in der Ebene gedreht
# orientierung y_1-direction: L, y_2-direction: T, x_3-direction: R
compliance_wood=np.array([[ 7.70543562e-05, -1.56584619e-05, -1.96144058e-05,
         0.00000000e+00,  0.00000000e+00,  0.00000000e+00],
       [-1.56584619e-05,  1.84913679e-03, -5.14793170e-04,
         0.00000000e+00,  0.00000000e+00,  0.00000000e+00],
       [-1.96144058e-05, -5.14793170e-04,  5.92975602e-04,
         0.00000000e+00,  0.00000000e+00,  0.00000000e+00],
       [ 0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
         2.25174559e-03,  0.00000000e+00,  0.00000000e+00],
       [ 0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
         0.00000000e+00,  7.95374719e-04,  0.00000000e+00],
       [ 0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
         0.00000000e+00,  0.00000000e+00,  1.19183673e-03]])
prestrain_wood=np.array([[-0.050821460301886785, 0, 0],                    
 [0, -2.134501332679245, 0],
 [0, 0, -0.8824453561509432]])
# rotation angle
param_theta = 1.5707963267948966

# untere Schicht: isotrop, ohne prestrain

# --- define geometry

def indicatorFunction(x):
    factor=1
    if (x[2]>=0):
        return 1  #Phase1
    else :
        return 2   #Phase2

# --- Number of material phases
Phases=2

# --- PHASE 1
phase1_type="general_anisotropic"
# Drehung um theta um Achse 2 = x_3-Achse
N=elast.rotation_matrix_compliance(2,param_theta)
materialParameters_phase1 = np.dot(np.dot(N,compliance_wood),N.T)
materialParameters_phase1 = (0.5*(materialParameters_phase1.T+materialParameters_phase1)).tolist()
# rotation of strain
def prestrain_phase1(x):
    R=elast.rotation_matrix(2,param_theta)
    return np.dot(R,np.dot(np.array(prestrain_wood),R.T)).tolist()

# --- PHASE 2
phase2_type="isotropic"
# extract E and nu from wood
E = 1/compliance_wood[0,0]
nu = -compliance_wood[0,1]*E
# [mu, lambda]
materialParameters_phase2 = [E/(2*(1+nu)), (E*nu)/((1+nu)*(1-2*nu))]
def prestrain_phase2(x):
    return [[0,0,0],[0,0,0],[0,0,0]]
